/**
 * This class was created by BrassGoggledCoders modding team.
 * This class is available as part of the BoilerCraft Mod for Minecraft.
 *
 * BoilerCraft is open-source and is distributed under the MMPL v1.0 License.
 * (http://www.mod-buildcraft.com/MMPL-1.0.txt)
 *
 */
package xyz.brassgoggledcoders.boilerplate.lib.common.items;

import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.text.translation.I18n;
import xyz.brassgoggledcoders.boilerplate.lib.client.ClientHelper;
import xyz.brassgoggledcoders.boilerplate.lib.common.utils.StringUtils;

import java.util.List;

/**
 * @author warlordjones
 *
 */
public class ItemBlockWithDesc extends ItemBlock
{
	Block block;

	public ItemBlockWithDesc(Block block)
	{
		super(block);
		this.block = block;
	}

	@SuppressWarnings("all")
	@Override
	public void func_77624_a(ItemStack stack, EntityPlayer entityPlayer, List list, boolean bool)
	{
		if (stack.func_77952_i() > 0)
		{
			if (!I18n.func_74838_a(this.block.func_149739_a() + "." + stack.func_77952_i() + ".desc").contains("tile."))
			{
				if (ClientHelper.isShiftKeyDown())
				{
					this.getWrappedDesc(list, stack);
				}
				else
				{
					list.add(ClientHelper.shiftForInfo);
				}
			}
		}
		else
		{
			if (!I18n.func_74838_a(this.block.func_149739_a() + ".desc").contains("tile."))
			{
				if (ClientHelper.isShiftKeyDown())
				{
					this.getWrappedDesc(list, stack);
				}
				else
				{
					list.add(ClientHelper.shiftForInfo);
				}
			}
		}
	}

	public void getWrappedDesc(List<String> list, ItemStack stack)
	{
		String[] wrappedDesc;
		if (stack.func_77952_i() > 0)
		{
			wrappedDesc = StringUtils.wrap(I18n.func_74838_a(this.func_77658_a() + "." + stack.func_77952_i() + ".desc"), 40);
		}
		else
		{
			wrappedDesc = StringUtils.wrap(I18n.func_74838_a(this.func_77658_a() + ".desc"), 40);
		}
		for (String element : wrappedDesc)
		{
			list.add(element.trim());
		}
	}
}
