package xyz.brassgoggledcoders.boilerplate.mod.items;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.ActionResult;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;
import xyz.brassgoggledcoders.boilerplate.api.IDebuggable;
import xyz.brassgoggledcoders.boilerplate.lib.client.models.IHasModel;
import xyz.brassgoggledcoders.boilerplate.lib.common.items.BaseItem;
import xyz.brassgoggledcoders.boilerplate.mod.Boilerplate;

import java.util.Iterator;
import java.util.LinkedHashMap;

/**
 * @author SkySom
 */
public class ItemDebuggerStick extends BaseItem implements IHasModel
{
	public ItemDebuggerStick()
	{
		super("debuggerstick");
		this.func_77637_a(CreativeTabs.field_78026_f);
	}

	public ActionResult<ItemStack> func_77659_a(ItemStack itemStack, World world, EntityPlayer player, EnumHand hand)
	{
		RayTraceResult rayTrace = func_77621_a(world, player, true);

		LinkedHashMap<String, String> debugStrings = new LinkedHashMap<String, String>();
		if(rayTrace != null && rayTrace.field_72313_a != null)
		{
			if (rayTrace.field_72313_a == RayTraceResult.Type.BLOCK)
			{
				TileEntity tileEntity = world.func_175625_s(rayTrace.func_178782_a());
				{
					if (tileEntity instanceof IDebuggable)
					{
						debugStrings.putAll(((IDebuggable) tileEntity).getDebugStrings());
					} else {
						debugStrings.put("name", world.func_180495_p(rayTrace.func_178782_a()).toString());
					}
				}
			}
			else if (rayTrace.field_72313_a == RayTraceResult.Type.ENTITY)
			{
				Entity entity = rayTrace.field_72308_g;
				if (entity instanceof IDebuggable)
				{
					debugStrings.putAll(((IDebuggable) entity).getDebugStrings());
				} else {
					debugStrings.put("name", entity.func_70005_c_());
				}
			}
		}

		if(!debugStrings.isEmpty())
		{
			Iterator<String> iterator = debugStrings.values().iterator();
			while(iterator.hasNext())
			{
				Boilerplate.logger.info(iterator.next());
			}
			return ActionResult.newResult(EnumActionResult.SUCCESS, itemStack);
		}

		return ActionResult.newResult(EnumActionResult.PASS, itemStack);
	}

	@Override
	public String[] getResourceLocations()
	{
		return new String[] {"debugger_stick"};
	}
}
